=Description
Name: Calc-P
Author name: SE
URL: http://www.geocities.jp/researcherinus/perl1
Description: The main objetcive of this script is for the author to study computer programing (Perl and C++) and mathematics.  But, it may also be helpful for daily use.  I do not know.
Development start data: April 27, 2007
=cut

#=pod
BEGIN{
  if ($^O eq 'MSWin32'){
    require Win32::Console;
    Win32::Console::Free();
  }
 }
#=cut

# ----------------------------------- #
#  Open source libraries and pragma   #
# ----------------------------------- #

use strict;
use warnings;
use Tk;
use Tk::Balloon;
use Encode;
use Math::Trig;
use Cwd;
our $curr_dir = Cwd::getcwd();

# ----------------------- #
#    Custom libraries     #
# ----------------------- #

use lib './lib';
use Convert;
use Gconvert;
use Function;
use Stat;

# ----------------------- #
#     Initialization      #
# ----------------------- #

unless (-e "log"){mkdir "log";}
unless (-e "data"){mkdir "data";}
open SYMIN, "< ./lib/symbol.dat";

my @syms = <SYMIN>;
close SYMIN;
my ($sym_rt,$sym_pi,$sym_gamma,$sym_beta) = @syms;
$sym_rt = decode('utf8',$sym_rt);
chomp $sym_rt;
$sym_pi = decode('utf8',$sym_pi);
chomp $sym_pi;
$sym_gamma = decode('utf8',$sym_gamma);
chomp $sym_gamma;
$sym_beta = decode('utf8',$sym_beta);
chomp $sym_beta;
#print "($sym_rt,$sym_pi,$sym_gamma,$sym_beta)\n";


# ----------------------- #
#       GUI design        #
# ----------------------- #

my $top = MainWindow->new();
$top->resizable(0,0);

# --- Menu bar --- #
my $m = $top->Menu();
$top->configure( -menu => $m );

my $m1 = $m->cascade(-label => 'File', -under => 0, -tearoff => 0);
$m1->command(-label => 'Exit', -under => 0, -command => [\&exit] );

# --- Frames --- #

my $f0_0 = $top->Frame(-borderwidth=>2, -relief=>'ridge')->grid(-column=>0, -row=>0, -columnspan=>5);       # Entry
my $f0_1 = $top->Frame(-borderwidth=>2, -relief=>'ridge')->grid(-column=>0, -row=>1);       # Numbers
my $f1_1 = $top->Frame(-borderwidth=>2, -relief=>'ridge')->grid(-column=>1, -row=>1);       # Basic operators
my $f2_1 = $top->Frame(-borderwidth=>2, -relief=>'ridge')->grid(-column=>2, -row=>1);       # Arithmetic functions
my $f3_1 = $top->Frame(-borderwidth=>2, -relief=>'ridge')->grid(-column=>3, -row=>1);       # Stats
my $f4_1 = $top->Frame(-borderwidth=>2, -relief=>'ridge')->grid(-column=>4, -row=>1);       # Advanced functions
my $f0_2 = $top->Frame(-borderwidth=>2, -relief=>'ridge')->grid(-column=>0, -row=>2, -columnspan=>1);       # AC and =
my $f1_2 = $top->Frame(-borderwidth=>2, -relief=>'ridge')->grid(-column=>1, -row=>2, -columnspan=>3);       # Move cursor
my $f2_2 = $top->Frame(-borderwidth=>2, -relief=>'ridge')->grid(-column=>4, -row=>2, -columnspan=>1);       # Show saved formula
my $f0_3 = $top->Frame(-borderwidth=>2, -relief=>'ridge')->grid(-column=>0, -row=>3, -columnspan=>5);       # Textarea

# --- Frame 0_0 data entry --- #

my $label0_0_1 = $f0_0->Label(-text=>'Fomula (Data 1)')->grid(-column=>0, -row=>0, -sticky=>'ew');

my $ent_txt1 ='';
my $entry1 = $f0_0->Entry(-textvariable=> \$ent_txt1, -justify=>'left',  -background=>'light yellow', -width => '40');
$entry1->grid(-column=>1, -row=>0); 
$entry1 ->focusForce();
$entry1 ->bind("<Key-Return>" => [\&answer,\$ent_txt1] );
$entry1 ->bind("<Key d>" => [\&allclear] );

my $label0_0_2 = $f0_0->Label(-text=>'Answer (Data 2)')->grid(-column=>0, -row=>1, -sticky=>'ew');

my $ent_txt2 ='';
my $entry2 = $f0_0->Entry(-textvariable=> \$ent_txt2, -justify=>'left',  -width => '40');
$entry2->grid(-column=>1, -row=>1); 
$entry2 ->bind("<Key-Return>" => [\&answer,\$ent_txt1] );
$entry2 ->bind("<Key d>" => [\&allclear] );

# --- Frame 0_1 numbers --- #

my $label0_1_1 = $f0_1->Label(-text=>'Numbers', -relief=>'groove', -background=>'gray')->grid(-column=>0, -row=>0, -columnspan=>3, -sticky=>'ew');

my $btn_7 = $f0_1->Button( -text => '7', -width=>3, -activebackground=>'gray', -command => [\&append, 7]);
$btn_7->grid(-column=>0, -row=>1);

my $btn_8 = $f0_1->Button( -text => '8', -width=>3, -activebackground=>'gray', -command => [\&append, 8]);
$btn_8->grid(-column=>1, -row=>1);

my $btn_9 = $f0_1->Button( -text => '9', -width=>3, -activebackground=>'gray', -command => [\&append, 9]);
$btn_9->grid(-column=>2, -row=>1);

my $btn_4 = $f0_1->Button( -text => '4', -width=>3, -activebackground=>'gray', -command => [\&append, 4]);
$btn_4->grid(-column=>0, -row=>2);

my $btn_5 = $f0_1->Button( -text => '5', -width=>3, -activebackground=>'gray', -command => [\&append, 5]);
$btn_5->grid(-column=>1, -row=>2);

my $btn_6 = $f0_1->Button( -text => '6', -width=>3, -activebackground=>'gray', -command => [\&append, 6]);
$btn_6->grid(-column=>2, -row=>2);

my $btn_1 = $f0_1->Button( -text => '1', -width=>3, -activebackground=>'gray', -command => [\&append, 1]);
$btn_1->grid(-column=>0, -row=>3);

my $btn_2 = $f0_1->Button( -text => '2', -width=>3, -activebackground=>'gray', -command => [\&append, 2]);
$btn_2->grid(-column=>1, -row=>3);

my $btn_3 = $f0_1->Button( -text => '3', -width=>3, -activebackground=>'gray', -command => [\&append, 3]);
$btn_3->grid(-column=>2, -row=>3);

my $btn_0 = $f0_1->Button( -text => '0', -width=>3, -activebackground=>'gray', -command => [\&append, 0]);
$btn_0->grid(-column=>0, -row=>4);

my $btn_dot = $f0_1->Button( -text => '.', -width=>3, -activebackground=>'gray', -command => [\&append, '.']);
$btn_dot->grid(-column=>1, -row=>4);

my $btn_exp = $f0_1->Button( -text => 'EXP', -width=>3, -activebackground=>'gray', -command => [\&append, 'E']);
$btn_exp->grid(-column=>2, -row=>4);


# --- Frame 1_1  Basic operators --- #

my $label1_1_1 = $f1_1->Label(-text=>'Basic', -relief=>'groove', -background=>'gray')->grid(-column=>0, -row=>0, -columnspan=>2, -sticky=>'ew');

my $btn_dev = $f1_1->Button( -text => '/', -width=>3, -activebackground=>'gray', -command => [\&append, '/']);
$btn_dev->grid(-column=>0, -row=>1);

my $btn_mul = $f1_1->Button( -text => 'x', -width=>3, -activebackground=>'gray', -command => [\&append, '*']);
$btn_mul->grid(-column=>0, -row=>2);

my $btn_minus = $f1_1->Button( -text => '-', -width=>3, -activebackground=>'gray', -command => [\&append, '-']);
$btn_minus->grid(-column=>0, -row=>3);

my $btn_plus = $f1_1->Button( -text => '+', -width=>3, -activebackground=>'gray', -command => [\&append, '+']);
$btn_plus->grid(-column=>0, -row=>4);

my $btn_lp = $f1_1->Button( -text => '(', -width=>3, -activebackground=>'gray', -command => [\&append, '(']);
$btn_lp ->grid(-column=>1, -row=>1);

my $btn_rp = $f1_1->Button( -text => ')', -width=>3, -activebackground=>'gray', -command => [\&append, ')']);
$btn_rp->grid(-column=>1, -row=>2);

my $btn_ac = $f1_1->Button( -text => 'MR', -width=>3, -activebackground=>'gray', -command => [\&record,\$ent_txt1,\$ent_txt2]);
$btn_ac->grid(-column=>1, -row=>3);

my $btn_ans = $f1_1->Button( -text => 'M+', -width=>3, -activebackground=>'gray', -command => [\&call]);
$btn_ans->grid(-column=>1, -row=>4);


# --- Frame 2_1 Power Logarithm Exponential --- #

my $label2_1_1 = $f2_1->Label(-text=>'Exp/Log', -relief=>'groove', -background=>'gray')->grid(-column=>0, -row=>0, -columnspan=>2, -sticky=>'ew');

my $btn_pow2 = $f2_1->Button( -text => 'x^2', -width=>3, -activebackground=>'gray', -command => [\&append, '^2']);
$btn_pow2->grid(-column=>0, -row=>1);

my $btn_pow = $f2_1->Button( -text => 'x^y', -width=>3, -activebackground=>'gray', -command => [\&append, '^']);
$btn_pow->grid(-column=>0, -row=>2);

my $btn_sqrt = $f2_1->Button( -textvariable => \$sym_rt, -width=>3, -activebackground=>'gray', -command => [\&append, 'R']);
$btn_sqrt->grid(-column=>0, -row=>3);

my $btn_nep = $f2_1->Button( -text => 'e', -width=>3, -activebackground=>'gray', -command => [\&append, 'e']);
$btn_nep->grid(-column=>0, -row=>4);

my $btn_ln = $f2_1->Button( -text => 'ln', -width=>3, -activebackground=>'gray', -command => [\&append, 'ln']);
$btn_ln->grid(-column=>1, -row=>1);

my $btn_log = $f2_1->Button( -text => 'log', -width=>3, -activebackground=>'gray', -command => [\&append, 'log']);
$btn_log->grid(-column=>1, -row=>2);

my $btn_log_ = $f2_1->Button( -text => 'loga', -width=>3, -activebackground=>'gray', -command => [\&append, 'lg_']);
$btn_log_ ->grid(-column=>1, -row=>3);

my $btn_fact = $f2_1->Button( -text => '!', -width=>3, -activebackground=>'gray', -command => [\&append, '!']);
$btn_fact->grid(-column=>1, -row=>4);

# --- Frame 3_1 trigonometry --- #

my $label3_1_1 = $f3_1->Label(-text=>'Trig', -relief=>'groove', -background=>'gray')->grid(-column=>0, -row=>0, -columnspan=>2, -sticky=>'ew');

my $btn_sin = $f3_1->Button( -text => 'sin', -width=>3, -activebackground=>'gray', -command => [\&append, 'sin']);
$btn_sin->grid(-column=>0, -row=>1);

my $btn_cos = $f3_1->Button( -text => 'cos', -width=>3, -activebackground=>'gray', -command => [\&append, 'cos']);
$btn_cos->grid(-column=>0, -row=>2);

my $btn_tan = $f3_1->Button( -text => 'tan', -width=>3, -activebackground=>'gray', -command => [\&append, 'tan']);
$btn_tan->grid(-column=>0, -row=>3);

our $deg_rad = 'RAD';
my $btn_dr = $f3_1->Button( -textvariable => \$deg_rad, -width=>3, -activebackground=>'gray', -command => [\&deg_rad]);
$btn_dr->grid(-column=>0, -row=>4);

my $btn_asin = $f3_1->Button( -text => 'asin', -width=>3, -activebackground=>'gray', -command => [\&append, 'asn']);
$btn_asin->grid(-column=>1, -row=>1);

my $btn_acos = $f3_1->Button( -text => 'acos', -width=>3, -activebackground=>'gray', -command => [\&append, 'acs']);
$btn_acos->grid(-column=>1, -row=>2);

my $btn_atan = $f3_1->Button( -text => 'atan', -width=>3, -activebackground=>'gray', -command => [\&append, 'atn']);
$btn_atan->grid(-column=>1, -row=>3);

my $btn_pi = $f3_1->Button( -textvariable => \$sym_pi, -width=>3, -activebackground=>'gray', -command => [\&append, 'pi']);
$btn_pi->grid(-column=>1, -row=>4);

# --- Frame 4_1 graph --- #

my $label4_1_1 = $f4_1->Label(-text=>'Graph', -borderwidth=>2, -relief=>'groove', -background=>'gray' )->grid(-column=>0, -row=>0, -columnspan=>3, -sticky=>'ew');

# default values
my $x_range = 10;
my $y_range = 10;
my $resln = 20;

my $btn_x = $f4_1->Button( -text => 'X', -width=>4, -activebackground=>'gray', -command =>  [\&append, 'X']);
$btn_x->grid(-column=>0, -row=>1);

my $btn_mv = $f4_1->Button( -text => 'f1>f2', -width=>4, -activebackground=>'gray', -command =>  [\&f1_f2]);
$btn_mv->grid(-column=>0, -row=>2);

my $btn_sf = $f4_1->Button( -text => 'save', -width=>4, -activebackground=>'gray', -command =>  [\&save_f, \$ent_txt1, \$ent_txt2]);
$btn_sf->grid(-column=>0, -row=>3);

my $label4_1_2 = $f4_1->Label(-text=>'x', -width=>3, -height=>1)->grid(-column=>1, -row=>1);

my $entry4_1_2 = $f4_1->Entry(-textvariable=> \$x_range, -justify=>'right',  -width => '3');
$entry4_1_2->grid(-column=>2, -row=>1);

my $label4_1_3 = $f4_1->Label(-text=> 'y', -width=>3)->grid(-column=>1, -row=>2);

my $entry4_1_3 = $f4_1->Entry(-textvariable=> \$y_range, -justify=>'right',  -width => '3');
$entry4_1_3->grid(-column=>2, -row=>2);

my $label4_1_4 = $f4_1->Label(-text=>'res', -width=>3)->grid(-column=>1, -row=>3);

my $entry4_1_4 = $f4_1->Entry(-textvariable=> \$resln, -justify=>'right',  -width => '3');
$entry4_1_4->grid(-column=>2, -row=>3);

my $btn_gra = $f4_1->Button(-text=>'Display', -activebackground=>'gray', -command => [\&disp_graph, \$ent_txt1, \$ent_txt2, \$x_range, \$y_range, \$resln])->grid(-column=>0, -row=>4, -columnspan=>3, -sticky=>'ew');


# --- Frame 0_2 All Clear and Get Answer --- #

my $btn_eq2 = $f0_2->Button( -text => '=', -width=>4, -activebackground=>'gray', -command => [\&answer, 'mock', \$ent_txt1]);
$btn_eq2->grid(-column=>1, -row=>0);

my $btn_ac2 = $f0_2->Button( -text => 'AC', -width=>4, -activebackground=>'gray', -command =>  [\&allclear]);
$btn_ac2->grid(-column=>0, -row=>0);


# --- Frame 1_2 Positioning & memory --- #

my $btn_top = $f1_2->Button( -text => '<<', -width=>4, -activebackground=>'gray', -command => [\&move, 0]);
$btn_top->grid(-column=>0, -row=>0);

my $btn_last = $f1_2->Button( -text => '>>', -width=>4, -activebackground=>'gray', -command => [\&move, 1]);
$btn_last->grid(-column=>1, -row=>0);

my $btn_left = $f1_2->Button( -text => '<', -width=>4, -activebackground=>'gray', -command => [\&move, 2]);
$btn_left->grid(-column=>2, -row=>0);

my $btn_right = $f1_2->Button( -text => '>', -width=>4, -activebackground=>'gray', -command => [\&move, 3]);
$btn_right->grid(-column=>3, -row=>0);

my $btn_bs = $f1_2->Button( -text => 'BS', -width=>4, -activebackground=>'gray', -command => [\&bs]);
$btn_bs->grid(-column=>4, -row=>0);

# --- Frame 2_2 Disp previous formula --- #

my $fpos = 0;

my $btn_prev = $f2_2->Button( -text => 'Prv', -width=>3, -activebackground=>'gray', -command => [\&dispf, \$fpos, 0]);
$btn_prev->grid(-column=>0, -row=>0);

my $btn_nxt = $f2_2->Button( -text => 'Nxt', -width=>3, -activebackground=>'gray', -command => [\&dispf, \$fpos, 1]);
$btn_nxt->grid(-column=>1, -row=>0);

# --- Frame 0_3 Text area --- #

my $textarea0_3 = $f0_3->Scrolled( 'Text', -scrollbars => 'e', -wrap => 'word', -width => '47', -height => '4')->grid(-row=>0,-column=>0);

# --- Manus requiring predefined variables, ex. ent_txt--- #

my $m1_2 = $m->cascade(-label => 'Hyp', -under => 0, -tearoff => 0);
$m1_2->command(-label => "sinh", -under => 0, -command => [\&append, 'snh'] );
$m1_2->command(-label => "cosh", -under => 0, -command => [\&append, 'csh'] );
$m1_2->command(-label => "tanh", -under => 0, -command => [\&append, 'tnh'] );

my $m1_3 = $m->cascade(-label => 'Prob', -under => 0, -tearoff => 0);
$m1_3->command(-label => "nPr", -under => 0, -command => [\&append, 'nPr[,]',2 ] );
$m1_3->command(-label => "nCr", -under => 0, -command => [\&append, 'nCr[,]',2 ] );

my $m2 = $m->cascade(-label => 'Func', -under => 0, -tearoff => 0);
$m2->command(-label => "Beta ($sym_beta)", -under => 0, -command => [\&append, 'B[,]',1] );
$m2->command(-label => "Gamma ($sym_gamma)", -under => 0, -command => [\&append, 'G[ ]',1] );

my $m2b = $m2->cascade( -label => 'Bessel', -tearoff => 0,-menuitems =>[
      ['command', 'Jn', -command => [\&append, 'Jn[,]',1 ] ],
     # ['command', 'Yn', -command => [\&append, 'Yn[ ]',1 ] ],
      ['command', 'In', -command => [\&append, 'In[,]',1 ] ]
      #['command', 'Kn', -command => [\&append, 'Kn[ ]',1 ] ]
      ]);

$m2->separator;
$m2->command(-label => 'Lambert W', -under => 0, -command => [\&append, 'W[ ]',1] );
$m2->separator;
$m2->command(-label => 'Legendre', -under => 0, -command => [\&append, 'Pn[,]',1] );
$m2->command(-label => 'Hermite', -under => 0, -command => [\&append, 'Hn[,]',1] );
$m2->command(-label => 'Laguerre', -under => 0, -command => [\&append, 'Ln[,]',1] );

my $m3 = $m->cascade(-label => 'Stats', -under => 0, -tearoff => 0);
$m3->command(-label => '< Import data >', -under => 0, -command => [\&import_file] );
$m3->separator;
$m3->command(-label => 'SD and more', -under => 0, -command => [\&prestat,'sd'] );
$m3->command(-label => 'F test', -under => 0, -command => [\&prestat,'Ft'] );
$m3->separator;
$m3->command(-label => 'Unpaired t test', -under => 0, -command => [\&prestat,'ut'] );
$m3->command(-label => 'Paired t test', -under => 0, -command => [\&prestat,'pt'] );
$m3->separator;
$m3->command(-label => 'Mann-Whitney U', -under => 0, -command => [\&prestat,'mw'] );
$m3->command(-label => 'Wilcoxson\'s signed', -under => 0, -command => [\&prestat,'wil'] );
$m3->separator;
$m3->command(-label => 'Pearson\'s', -under => 0, -command => [\&prestat,'prsn'] );
$m3->command(-label => 'Spearman\'s', -under => 0, -command => [\&prestat,'spem'] );

 #my $ans = eval((log(3)/log(10)));
 #print "test ans=$ans\n";

MainLoop;


# ----------------------- #
#       Subroutines       #
# ----------------------- #

    
# --- Subroutines for Display Graph -- #

sub f1_f2{
    $ent_txt2 = $ent_txt1;
    $ent_txt1='';
}

sub disp_graph{
    my ($formula, $formula2, $x_range, $y_range, $resln) = @_;
    ($formula, $formula2, $x_range, $y_range, $resln)
        = ($$formula, $$formula2, $$x_range, $$y_range, $$resln);
    $x_range *= 2;
    $y_range *= 2;

    if ($x_range*$resln>800||$y_range*$resln>800){
        print "x (or y) * res should be lower than 400.\n";
        $textarea0_3->insert('0.0', "x (or y) * res should be lower than 400.\n" );
        return;
    }

    my $plot_n = 1;
    $plot_n = 2 if ($formula2 ne '');
    
    my $x_max_size = $x_range*$resln;
    my $y_max_size = $y_range*$resln;
    
    my $x_zero_p = $x_max_size/2;
    my $y_zero_p = $y_max_size/2;
    
    # create a new image
    my $mw = MainWindow->new();
    my $canvas1 = $mw->Canvas( width => $x_max_size, height => $y_max_size, -background=>'white',-cursor=>"crosshair" );
    $canvas1->pack();

    my $id;
    
    # draw x and y axis
    my $x_axis = $canvas1->create( 'line', 0,$y_zero_p,$x_max_size, $y_zero_p, -fill=>'blue', -arrow => 'last' );
    my $y_axis = $canvas1->create( 'line', $x_zero_p, 0,$x_zero_p, $y_max_size, -fill=>'blue', -arrow => 'first' );
    
    # draw grids
    if ($x_range<=100&&$y_range<=100){
        for (1..$x_range-1){
            my $x_grid = $canvas1->create( 'line', $_*$resln, $y_zero_p-5, $_*$resln, $y_zero_p+5, -fill=>'blue' );
            if ($resln>=10){
                $canvas1->create( 'text', $_*$resln, $y_zero_p+10, -text => $_-$x_range/2, -fill=>'blue') unless ($_-$x_range/2==0);
            }
        }
        for (1..$y_range-1){
            my $y_grid = $canvas1->create( 'line', $x_zero_p-5, $_*$resln,  $x_zero_p+5, $_*$resln, -fill=>'blue' );
            if ($resln>=10){
                $canvas1->create( 'text',  $x_zero_p+10, $_*$resln, -text => -1*($_-$y_range/2), -fill=>'blue') unless ($_-$y_range/2==0);
            }
        }
    }
    
    # loop for calculation and drawing graph(s)
    for (my $i=0;$i<$plot_n;$i++){
        
        if ($i == 1){
            $formula=$formula2;
        }
        
        $formula = &gconvert($formula);
        $formula =~ s{B\[(.+?)\,(.+?)\]}{&Function::beta\( &gconvert\($1\),&gconvert\($2\) \)}g;    # Beta
        $formula =~ s{G\[(.+?)\]}{&Function::gamma\(&gconvert\($1\)\)}g;    # Gamma
        $formula =~ s{W\[(.+?)\]}{&Function::lambert\(&gconvert\($1\)\)}g;    # Lambert W
        $formula =~ s{Pn\[(\d+)\,(.+?)\]}{&Function::legendre\(&gconvert\($2\),$1\)}g;    # Legendre
        $formula =~ s{Hn\[(\d+)\,(.+?)\]}{&Function::hermite\(&gconvert\($2\),$1\)}g;    # Hermite
        $formula =~ s{Ln\[(\d+)\,(.+?)\]}{&Function::laguerre\(&gconvert\($2\),$1\)}g;    # Laguerre
        $formula =~ s{Jn\[(.+?)\,(.+?)\]}{&Function::Jn\( $1, &gconvert\($2\) \)}g;    # Bessel J
        $formula =~ s{In\[(.+?)\,(.+?)\]}{&Function::In\( $1, &gconvert\($2\) \)}g;    # Bessel I
        
        $formula =~ s{nPr\[(.+?)\,(.+?)\]}{&Function::nPr\( &gconvert\($1\),&gconvert\($2\) \)}g;    # nPr
        $formula =~ s{nCr\[(.+?)\,(.+?)\]}{&Function::nCr\( &gconvert\($1\),&gconvert\($2\) \)}g;    # nCr
        
        my $test_formula = $formula;
        $test_formula =~ s/X/1/;
        my $answer = eval($test_formula);
        $answer = "Error" if !defined $answer;
        
        print "formula=$formula\n" if $formula2;
        $textarea0_3->insert('0.0', "formula=$formula\n" );
        
        my $input_f1 = $formula;
        
        my $input_f2 = $input_f1;
        $input_f1  =~ s/X/\$x1/g;
        $input_f2  =~ s/X/\$x2/g;
        
        my $stride = 1/$resln;
        my $curr = -$x_zero_p/$resln;
        for (-$x_zero_p..$x_zero_p){
            my $x1 = $curr;
            my $y1 = eval($input_f1);
            my $x2 = $x1+$stride;
            my $y2 = eval($input_f2);

            if (!defined $y1 || !defined $y2 || $y1 =~ /i$/ || $y2 =~ /i$/){
                $curr+=$stride;
                next;
            }
            
            my $x1_plot = $x1*$resln+$x_zero_p;
            my $x2_plot = $x2*$resln+$x_zero_p;
            my $y1_plot = -1*($y1)*$resln+$y_zero_p;
            my $y2_plot = -1*($y2)*$resln+$y_zero_p;
            
            if ($i==0){
                #$img->line($x1_plot,$y1_plot,$x2_plot,$y2_plot,$red);
                $id = $canvas1->create( 'line', $x1_plot,$y1_plot,$x2_plot,$y2_plot, -fill=>'red' );
                $canvas1->bind($id, '<ButtonPress-1>' => [\&disp_point, Ev('x'), Ev('y'),$x_zero_p,$y_zero_p]);
            }elsif($i==1){
                #$img->line($x1_plot,$y1_plot,$x2_plot,$y2_plot,$green);
                $id = $canvas1->create( 'line', $x1_plot,$y1_plot,$x2_plot,$y2_plot, -fill=>'green' );
                $canvas1->bind($id, '<ButtonPress-1>' => [\&disp_point, Ev('x'), Ev('y'),$x_zero_p,$y_zero_p]);
            }
            $curr+=$stride;
        }    
    }

    $canvas1-> postscript(-file=>'graph.ps', -height => $y_max_size, -width => $x_max_size );
    
}

sub disp_point{
    my $x_pnt = $_[1];
    my $y_pnt = $_[2];
    my $x_zero_p = $_[3];
    my $y_zero_p = $_[4];
    
    $x_pnt = (($x_pnt-$x_zero_p)/$resln);
    $y_pnt = -1*(($y_pnt-$y_zero_p)/$resln);
    
    print "(x,y)=($x_pnt,$y_pnt)\n";
    $textarea0_3->insert('0.0', "(x,y)=($x_pnt,$y_pnt)\n" );
}


# --- Subroutines for Get Answer -- #

sub answer{
    my $formula = $_[1];
    $formula= $$formula;
    
    $formula = &convert($formula);
    $formula =~ s{B\[(.+?)\,(.+?)\]}{&Function::beta\( &gconvert\($1\),&gconvert\($2\) \)}g;    # Beta
    $formula =~ s{G\[(.+?)\]}{&Function::gamma\(&convert\($1\)\)}g;    # Gamma
    $formula =~ s{W\[(.+?)\]}{&Function::lambert\(&convert\($1\)\)}g;    # Lambert W
    $formula =~ s{Pn\[(\d+)\,(.+?)\]}{&Function::legendre\(&convert\($2\),$1\)}g;    # Legendre
    $formula =~ s{Hn\[(\d+)\,(.+?)\]}{&Function::hermite\(&convert\($2\),$1\)}g;    # Hermite
    $formula =~ s{Ln\[(\d+)\,(.+?)\]}{&Function::laguerre\(&convert\($2\),$1\)}g;    # Laguerre
    $formula =~ s{Jn\[(.+?)\,(.+?)\]}{&Function::Jn\( $1,&convert\($2\) \)}g;    # Bessel J
    $formula =~ s{In\[(.+?)\,(.+?)\]}{&Function::In\( $1,&convert\($2\) \)}g;    # Bessel I
    
    $formula =~ s{nPr\[(.+?)\,(.+?)\]}{&Function::nPr\( $1,$2 \)}g;    # nPr
    $formula =~ s{nCr\[(.+?)\,(.+?)\]}{&Function::nCr\( $1,$2 \)}g;    # nCr
    
    my $answer = eval($formula);
    $answer = "Error" if !defined $answer;
    if ($answer =~ /i$/){$ent_txt2 = "=$answer"; return;}
    
    my $formatans;
    if ($answer =~ /\./){
        $formatans = sprintf("%.5f",$answer);
    }else{
        $formatans = $answer;
    }
    $formatans = $1 if ($formatans =~ /(.+)\.00000/);
    $formatans = 0 if ($formatans eq '-0');

    $ent_txt2 = "=$formatans";
    print "$formula=$formatans\n";
    $textarea0_3->insert('0.0', "$formula=$formatans\n" );
}


# --- Subroutines for Calculations -- #

sub deg_rad{
    if ($deg_rad eq 'RAD'){
        $deg_rad = 'DEG';
    }else{
        $deg_rad = 'RAD';
    }
}

sub fact{
    my $ininum = shift;
    my $fact = 1;
    for (1..$ininum){
        $fact*=$ininum;
        $ininum--;
    }
    return $fact;
}

sub append{
    my $item = shift;
    my $aflg = shift;
    my $curr_index = $entry1->index('insert');
    $entry1->insert("$curr_index.0", $item);
    if ($aflg){
      $curr_index = $curr_index+$aflg+2;
      $entry1->icursor($curr_index);
    }
}

sub allclear{
    $ent_txt1 = '';
    $ent_txt2 = '';
}


# --- subroutines for Memory -- #

sub record{
    my ($dat1, $dat2) = @_;
    ($dat1, $dat2) = ($$dat1, $$dat2);
    $dat2 =~ s/=//;
    
    open MOUT, "> log/memory.dat";
    print MOUT "[formula]$dat1\n[answer]$dat2\n";
    close MOUT;
}

sub call{
    open MIN, "< log/memory.dat";
    my $mdata;
    {local $/;
     $mdata=<MIN>;}
    my ($mformula) = $mdata =~ /^\[formula\](.+?)$/sm;
    my ($manswer) = $mdata =~ /^\[answer\](.+?)$/sm;
    print "Memory: $mformula=$manswer\n";
    my $curr_index = $entry1->index('insert');
    $entry1->insert("$curr_index.0", $manswer);
}


# --- subroutines for Frame 0_2 positioning--- #

sub bs{
    my $curr_index = $entry1->index('insert');
    my $prev_index = $curr_index-1;
    $entry1->delete("$prev_index.0","$curr_index.0");
}

sub move{
    my $d_arg = shift;
    my $curr_index = $entry1->index('insert');
    my $index;

    if ($d_arg==0){
        $index = '0.0';
    }elsif($d_arg==1){
        $index = 'end';
    }elsif($d_arg==2){
        my $ml = $curr_index-1;
        $index = "$ml.0";
    }else{
        my $mr = $curr_index+1;
        $index = "$mr.0";
    }

    $entry1->icursor($index);
}

# --- Save and display formula ---

sub save_f{
    my $fml1 = shift;
    $fml1 = $$fml1;
    my $fml2 = shift;
    $fml2 = $$fml2;
    
    open MOUT, ">> log/formula.dat";
    print MOUT "$fml1\t$fml2\n";
    close MOUT;
}

sub dispf{
    my $s_fpos = shift;
    $s_fpos = $$s_fpos;
    my $pon = shift;

    open FIN, "< log/formula.dat";
    my @fdata = <FIN>;
    
    my $totnum = $#fdata;
    my $disp_f_num = $totnum-$s_fpos;
    
    if (!$fdata[$disp_f_num]){$fpos=0; return;}
    my @fmls = split /\t/, $fdata[$disp_f_num];

    $ent_txt1 = '';
    $ent_txt2 = '';
    
    $entry1->insert("0.0", $fmls[0]);
    $entry2->insert("0.0", $fmls[1]);

    if ($pon==0){
        $fpos++;
    }elsif($pon==1&&$fpos>0){
        $fpos--;
    }
}


# --- Subroutines for Statistics -- #

sub import_file{
  my $file = $top->getOpenFile(-filetypes => [['Text files',
'.txt'], ['CSV files','.csv'],['All Files', '*.*']], -initialdir =>$curr_dir);
  
  if ($file){
    open DATIN, "< $file" or die;
    my @datain = <DATIN>;
    my @test = split /\t+|\s+|,\s*/, $datain[0];
    if ($#test < 0){
        $ent_txt1 = "No data found.";
        return;
    }elsif($#test > 1){
        $ent_txt1 = $datain[0];
        $ent_txt2 = $datain[1];
    }else{
        $ent_txt1 = "";
        $ent_txt2 = "";
        foreach my $dataset (@datain){
            my ($data1,$data2) = split /\t+|\s+|,\s*/, $dataset;
            $entry1->insert('end', "$data1 ");
            $entry2->insert('end', "$data2 ");
        }
    }
    close DATIN;
  }
}

sub prestat{
    my $type = shift;
    my @data1 = split /\t+|\s+|,\s*/, $ent_txt1;
    my @data2 = split /\t+|\s+|,\s*/, $ent_txt2;
    my @results; my $disp_result;
    my $loop = ($#data1 >= 0 && $#data2 == -1) ? 1 :
                ($#data1 >= 0 && $#data2 >= 0) ? 2 : -1;
    return if $loop==-1;    
    
    # --- Basic values --- #
    my @data;
    my @disp;
    if ($type eq 'sd'){
        for (1..$loop){
            undef @data;
            @data = $_ == 1 ? @data1 : @data2;
            @results = &Stat::sd(\@data);
            my $cv = $results[4]/$results[3]*100;
            $cv = sprintf("%.3f",$cv);
            my $avg = sprintf("%.3f",$results[3]);
            my $sd = sprintf("%.3f",$results[4]);
            push @disp,"Data $_:\n\tn = $results[0], Avg. = $avg\n\tSD = $sd, CV(%) = $cv\n";
        }
        @disp = reverse @disp;
        $textarea0_3->insert('0.0', $_) foreach @disp;
    }
    
    # --- F test --- #
    if ($type eq 'Ft'){
        return if $loop !=2;
        my ($f12,$pf) = &Stat::ftest(\@data1,\@data2);
        $f12 = sprintf("%.3f",$f12);
        $pf = sprintf("%.5f",$pf);
        $disp_result = "F test:\n\tF=$f12\n\tp=$pf\n";
        $textarea0_3->insert('0.0', $disp_result);
    }
    
    # --- Paired t test --- #
    if ($type eq 'pt'){
        return if $loop !=2;
        my ($ptt,$ptp) = &Stat::pairedt(\@data1,\@data2);
        $ptt = sprintf("%.3f",$ptt);
        $ptp = sprintf("%.5f",$ptp);
        $disp_result = "Paired t test:\n\tt=$ptt\n\tp=$ptp\n";
        $disp_result = "Paired t test:\n\tInvalid parameter(s).\n"
            if ($ptt==0&&$ptp==0);
        $textarea0_3->insert('0.0', $disp_result);
    }
    
    # --- Unpaired t test --- #
    if ($type eq 'ut'){
        return if $loop !=2;
        my ($utt,$utp) = &Stat::unpairedt(\@data1,\@data2);
        $utt = sprintf("%.3f",$utt);
        $utp = sprintf("%.5f",$utp);
        $disp_result = "Unpaired t test:\n\tt=$utt\n\tp=$utp\n";
        $disp_result = "Unpaired t test:\n\tInvalid parameter(s).\n"
            if ($utt==0&&$utp==0);
        $textarea0_3->insert('0.0', $disp_result);
    }
    
        # --- Mann-Whitney U test --- #
    if ($type eq 'mw'){
        return if $loop !=2;
        my ($umw,$zmw,$pmw) = &Stat::mannwhitney(\@data1,\@data2);
        $umw = sprintf("%.3f",$umw);
        $zmw = sprintf("%.3f",$zmw);
        $pmw = sprintf("%.5f",$pmw);
        $disp_result = "Mann-Whitney U test:\n\tU=$umw\n\tz=$zmw\n\tp=$pmw\n";
        $disp_result = "Mann-Whitney U test:\n\tInvalid parameter(s).\n"
            if ($umw==0&&$zmw==0&&$pmw==0);
        $textarea0_3->insert('0.0', $disp_result);
    }

    # --- Wilcoxson's signed rank test --- #
    if ($type eq 'wil'){
        return if $loop !=2;
        my ($twl,$zwl,$pwl) = &Stat::wilcoxson(\@data1,\@data2);
        $twl = sprintf("%.3f",$twl);
        $zwl= sprintf("%.3f",$zwl);
        $pwl = sprintf("%.5f",$pwl);
        $disp_result = "Wilcoxson's signed rank test:\n\tT=$twl\n\tz=$zwl\n\tp=$pwl\n";
        $disp_result = "Wilcoxson's signed rank test:\n\tInvalid parameter(s).\n"
            if ($twl==0&&$zwl==0&&$pwl==0);
        $textarea0_3->insert('0.0', $disp_result);
    }
    
    # --- Pearson correlation --- #
    if ($type eq 'prsn'){
        return if $loop !=2;
        my ($r,$z, $p) = &Stat::pearson(\@data1,\@data2);
        $r = sprintf("%.3f",$r);
        $z = sprintf("%.3f",$z);
        $p = sprintf("%.5f",$p);
        $disp_result = "Pearson's correlation:\n\tr=$r\n\tz=$z\n\tp=$p\n";
        $disp_result = "Pearson's correlation:\n\tInvalid parameter(s).\n"
            if ($r==0&&$z==0&&$p==0);
        $textarea0_3->insert('0.0', $disp_result);
    }
    
    # --- Spearman's correlation --- #
    if ($type eq 'spem'){
        return if $loop !=2;
        my ($rsp,$zsp, $psp) = &Stat::spearman(\@data1,\@data2);
        $rsp = sprintf("%.3f",$rsp);
        $zsp = sprintf("%.3f",$zsp);
        $psp = sprintf("%.5f",$psp);
        $disp_result = "Spearman's correlation:\n\tr=$rsp\n\tz=$zsp\n\tp=$psp\n";
        $disp_result = "Spearman's correlation:\n\tInvalid parameter(s).\n"
            if ($rsp==0&&$zsp==0&&$psp==0);
        $textarea0_3->insert('0.0', $disp_result);
    }
    
}

__END__