package Convert;

use Exporter;
@ISA = (Exporter);
@EXPORT = qw(convert);
    
sub convert{
    
    my $formula = shift;
    
    $formula =~ s/\s//g;            # Remove spaces
    $formula =~ s{e}{exp\(1\)}g;    # Napier's constant
    $formula =~ s{\^}{\*\*}g;       # pow
    
    $formula =~ s{(\d+)R((\d|\.)+)}{$2\*\*\(1/$1\)}g;   # root (of power)
    $formula =~ s{(\d+)R\((.+?)\)}{\($2\)\*\*(1/$1\)}g;    # root (of power)
    $formula =~ s{R((\d|\.)+)}{sqrt\($1\)}g;   # root
    $formula =~ s{R\((.+?)\)}{sqrt\($1\)}g;    # root
    $formula =~ s{log\((.+?)\)}{\(log\($1\)/log\(10\)\)}g;    # log_10
    $formula =~ s{log((\d|\.)+)}{\(log\($1\)/log\(10\)\)}g;   # log_10
    $formula =~ s{ln((\d|\.)+)}{log\($1\)}g;   # log_e
    $formula =~ s{ln\((.+?)\)}{log\($1\)}g;    # log_e
    $formula =~ s{lg(\d+)_((\d|\.)+)}{\(log\($2\)/log\($1\)\)}g;   # log_a
    $formula =~ s{(\d+)\!}{&main::fact($1)}ge;    # log_e

    if ($main::deg_rad eq 'RAD'){
        $formula =~ s{sin\((.+?)\)}{sin\($1\)}g;    # sin
        $formula =~ s{sin((\d|\.)+)}{sin\($1\)}g;   # sin
        $formula =~ s{cos\((.+?)\)}{cos\($1\)}g;    # cos
        $formula =~ s{cos((\d|\.)+)}{cos\($1\)}g;   # cos
        $formula =~ s{tan\((.+?)\)}{tan\($1\)}g;    # tan
        $formula =~ s{tan((\d|\.)+)}{tan\($1\)}g;   # tan
        $formula =~ s{asn\((.+?)\)}{asin\($1\)}g;    # asin
        $formula =~ s{asn((\d|\.)+)}{asin\($1\)}g;   # asin
        $formula =~ s{acs\((.+?)\)}{acos\($1\)}g;    # acos
        $formula =~ s{acs((\d|\.)+)}{acos\($1\)}g;   # acos
        $formula =~ s{atn\((.+?)\)}{atan\($1\)}g;    # atan
        $formula =~ s{atn((\d|\.)+)}{atan\($1\)}g;   # atan
    }else{  # --- When DEG --- #
        $formula =~ s{sin\((.+?)\)}{sin\($1\*pi/180\)}g;    # sin
        $formula =~ s{sin((\d|\.)+)}{sin\($1\*pi/180\)}g;   # sin
        $formula =~ s{cos\((.+?)\)}{cos\($1\*pi/180\)}g;    # cos
        $formula =~ s{cos((\d|\.)+)}{cos\($1\*pi/180\)}g;   # cos
        $formula =~ s{tan\((.+?)\)}{tan\($1\*pi/180\)}g;    # tan
        $formula =~ s{tan((\d|\.)+)}{tan\($1\*pi/180\)}g;   # tan
        $formula =~ s{asn\((.+?)\)}{asin\($1\*pi/180\)}g;    # sin
        $formula =~ s{asn((\d|\.)+)}{asin\($1\*pi/180\)}g;   # sin
        $formula =~ s{acs\((.+?)\)}{acos\($1\*pi/180\)}g;    # cos
        $formula =~ s{acs((\d|\.)+)}{acos\($1\*pi/180\)}g;   # cos
        $formula =~ s{atn\((.+?)\)}{atan\($1\*pi/180\)}g;    # tan
        $formula =~ s{atn((\d|\.)+)}{atan\($1\*pi/180\)}g;   # tan
    }
    $formula =~ s{snh\((.+?)\)}{sinh\($1\)}g;    # sinh
    $formula =~ s{snh((\d|\.)+)}{sinh\($1\)}g;   # sinh
    $formula =~ s{csh\((.+?)\)}{cosh\($1\)}g;    # cosh
    $formula =~ s{csh((\d|\.)+)}{cosh\($1\)}g;   # cosh
    $formula =~ s{tnh\((.+?)\)}{tanh\($1\)}g;    # tanh
    $formula =~ s{tnh((\d|\.)+)}{tanh\($1\)}g;   # tanh
    
    return $formula;
}

return 1;