package Gconvert;

use Function;
use Exporter;
@ISA = (Exporter);
@EXPORT = qq(gconvert);


sub gconvert{
    my $formula = shift;
    
    $formula =~ s/\s//g;            # Remove spaces
    $formula =~ s{e}{exp\(1\)}g;    # Napier's constant
    $formula =~ s{\^}{\*\*}g;       # pow
    
    $formula =~ s{(\d+)R(X)}{$2\*\*\(1/$1\)}g;   # root (of power)
    $formula =~ s{(\d+)R\((.+?)\)}{\($2\)\*\*(1/$1\)}g;    # root (of power)
    $formula =~ s{R((\d|\.|X)+)}{sqrt\($1\)}g;   # root
    $formula =~ s{R\((.+?)\)}{sqrt\($1\)}g;    # root
    $formula =~ s{log\((.+?)\)}{\(log\($1\)/log\(10\)\)}g;    # log_10
    $formula =~ s{log((\d|\.|X)+)}{\(log\($1\)/log\(10\)\)}g;   # log_10
    $formula =~ s{ln((\d|\.|X)+)}{log\($1\)}g;   # log_e
    $formula =~ s{ln\((.+?)\)}{log\($1\)}g;    # log_e
    $formula =~ s{lg(\d+)_((\d|\.|X)+)}{\(log\($2\)/log\($1\)\)}g;   # log_a
    $formula =~ s{((\d+)|X)\!}{&main::fact($1)}ge;    # log_e

    if ($main::deg_rad eq 'RAD'){
        $formula =~ s{sin\((.+?)\)}{sin\($1\)}g;    # sin
        $formula =~ s{sin((\d|\.|X)+)}{sin\($1\)}g;   # sin
        $formula =~ s{cos\((.+?)\)}{cos\($1\)}g;    # cos
        $formula =~ s{cos((\d|\.|X)+)}{cos\($1\)}g;   # cos
        $formula =~ s{tan\((.+?)\)}{tan\($1\)}g;    # tan
        $formula =~ s{tan((\d|\.|X)+)}{tan\($1\)}g;   # tan
        $formula =~ s{asn\((.+?)\)}{asin\($1\)}g;    # asin
        $formula =~ s{asn((\d|\.|X)+)}{asin\($1\)}g;   # asin
        $formula =~ s{acs\((.+?)\)}{acos\($1\)}g;    # acos
        $formula =~ s{acs((\d|\.|X)+)}{acos\($1\)}g;   # acos
        $formula =~ s{atn\((.+?)\)}{atan\($1\)}g;    # atan
        $formula =~ s{atn((\d|\.|X)+)}{atan\($1\)}g;   # atan
    }else{  # --- When DEG --- #
        $formula =~ s{sin\((.+?)\)}{sin\($1\*pi/180\)}g;    # sin
        $formula =~ s{sin((\d|\.|X)+)}{sin\($1\*pi/180\)}g;   # sin
        $formula =~ s{cos\((.+?)\)}{cos\($1\*pi/180\)}g;    # cos
        $formula =~ s{cos((\d|\.|X)+)}{cos\($1\*pi/180\)}g;   # cos
        $formula =~ s{tan\((.+?)\)}{tan\($1\*pi/180\)}g;    # tan
        $formula =~ s{tan((\d|\.|X)+)}{tan\($1\*pi/180\)}g;   # tan
        $formula =~ s{asn\((.+?)\)}{asin\($1\*pi/180\)}g;    # sin
        $formula =~ s{asn((\d|\.|X)+)}{asin\($1\*pi/180\)}g;   # sin
        $formula =~ s{acs\((.+?)\)}{acos\($1\*pi/180\)}g;    # cos
        $formula =~ s{acs((\d|\.|X)+)}{acos\($1\*pi/180\)}g;   # cos
        $formula =~ s{atn\((.+?)\)}{atan\($1\*pi/180\)}g;    # tan
        $formula =~ s{atn((\d|\.|X)+)}{atan\($1\*pi/180\)}g;   # tan
    }
    $formula =~ s{snh\((.+?)\)}{sinh\($1\)}g;    # sinh
    $formula =~ s{snh((\d|\.|X)+)}{sinh\($1\)}g;   # sinh
    $formula =~ s{csh\((.+?)\)}{cosh\($1\)}g;    # cosh
    $formula =~ s{csh((\d|\.|X)+)}{cosh\($1\)}g;   # cosh
    $formula =~ s{tnh\((.+?)\)}{tanh\($1\)}g;    # tanh
    $formula =~ s{tnh((\d|\.|X)+)}{tanh\($1\)}g;   # tanh
        
    return $formula;
}

return 1;
    
    

